# coding: utf-8
"""Waylay Resources models.

This code was generated from the OpenAPI documentation of 'Waylay Resources'

Generated by OpenAPI Generator (https://openapi-generator.tech)

Do not edit the class manually.

"""

from __future__ import annotations

from typing import List

from pydantic import (
    ConfigDict,
    Field,
    StrictBool,
)
from typing_extensions import (
    Annotated,  # >=3.11
)
from waylay.sdk.api._models import BaseModel as WaylayBaseModel
from waylay.sdk.api._models import Model as GenericModel

from ..models.array_must_contain_inner import ArrayMustContainInner
from ..models.array_value_constraint_type import ArrayValueConstraintType


class ArrayValueConstraint(WaylayBaseModel):
    """Specifies that a value must be an array and what type of elements it contains."""

    type: ArrayValueConstraintType
    element_type: GenericModel = Field(alias="elementType")
    min_length: Annotated[int, Field(strict=True, ge=0)] | None = Field(
        default=None, alias="minLength"
    )
    max_length: Annotated[int, Field(strict=True, ge=0)] | None = Field(
        default=None, alias="maxLength"
    )
    unique_values: StrictBool | None = Field(
        default=False,
        description="If true, all values in the array must be unique.",
        alias="uniqueValues",
    )
    contains: List[ArrayMustContainInner] | None = Field(
        default=None,
        description="Only supported if the `elementType` is `boolean`, `numeric` or `string`. Specifies values the array attribute must contain.",
    )

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
        extra="ignore",
    )
