# coding: utf-8
"""Waylay Resources models.

This code was generated from the OpenAPI documentation of 'Waylay Resources'

Generated by OpenAPI Generator (https://openapi-generator.tech)

Do not edit the class manually.

"""

from __future__ import annotations

import re
from datetime import datetime

from pydantic import (
    ConfigDict,
    Field,
    field_validator,
)
from typing_extensions import (
    Annotated,  # >=3.11
)
from waylay.sdk.api._models import BaseModel as WaylayBaseModel

from ..models.resource_change_change import ResourceChangeChange
from ..models.resource_id import ResourceId
from ..models.resource_with_id_entity import ResourceWithIdEntity


class ResourceChange(WaylayBaseModel):
    """ResourceChange."""

    time: datetime
    resource_id: ResourceId = Field(alias="resourceId")
    user_id: Annotated[str, Field(strict=True)] = Field(
        description="User subject id in the Waylay Accounts database", alias="userId"
    )
    change: ResourceChangeChange
    resource: ResourceWithIdEntity | None = None

    @field_validator("user_id")
    @classmethod
    def user_id_validate_regular_expression(cls, value):
        """Validate the regular expression."""
        if not re.match(
            r"[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}", value
        ):
            raise ValueError(
                r"must validate the regular expression /[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}/"
            )
        return value

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
        extra="ignore",
    )
