# coding: utf-8
"""Waylay Resources models.

This code was generated from the OpenAPI documentation of 'Waylay Resources'

Generated by OpenAPI Generator (https://openapi-generator.tech)

Do not edit the class manually.

"""

from __future__ import annotations

from typing import List

from pydantic import (
    ConfigDict,
    Field,
    StrictBool,
)
from waylay.sdk.api._models import BaseModel as WaylayBaseModel

from ..models.attribute_item import AttributeItem
from ..models.resource_ref_value_constraint_type import ResourceRefValueConstraintType
from ..models.resource_type_id import ResourceTypeId


class ResourceRefValueConstraint(WaylayBaseModel):
    """Specifies that a value is an object having a required '$ref' attribute that references another _Resource_.."""

    type: ResourceRefValueConstraintType | None = None
    attributes: List[AttributeItem] | None = Field(
        default=None,
        description="Additional attributes in the reference object, describing the relation.",
    )
    resource_types: List[ResourceTypeId] | None = Field(
        default=None,
        description="The possible _Resource Types_ for the referenced _Resource_.",
        alias="resourceTypes",
    )
    exists: StrictBool | None = Field(
        default=False,
        description="Flag to indicate if the referenced _Resource_ must exist",
    )

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
        extra="ignore",
    )
