# coding: utf-8
"""Waylay Resources models.

This code was generated from the OpenAPI documentation of 'Waylay Resources'

Generated by OpenAPI Generator (https://openapi-generator.tech)

Do not edit the class manually.

"""

from __future__ import annotations

import re

from pydantic import (
    ConfigDict,
    Field,
    field_validator,
)
from typing_extensions import (
    Annotated,  # >=3.11
)
from waylay.sdk.api._models import BaseModel as WaylayBaseModel


class ResourceReference(WaylayBaseModel):
    """Represents a reference to a _Resource_."""

    ref: Annotated[str, Field(strict=True)] = Field(
        description="A URI for the _Resource_, formatted as `/resources/{resourceId}`",
        alias="$ref",
    )

    @field_validator("ref")
    @classmethod
    def ref_validate_regular_expression(cls, value):
        """Validate the regular expression."""
        if not re.match(r"^\/resources\/.*", value):
            raise ValueError(r"must validate the regular expression /^\/resources\/.*/")
        return value

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
        extra="allow",
    )
